import React from 'react'
import css from './frame.scss'
import KaraCalendarCreate from '../kara-calendar-create'
import './skins/default/skin.css'
import {tost, tosts} from 'karaui';
import httpAgent from "./httpAgent";
import './layout.css'

const {errorTost} = tosts

export default class Co extends React.Component {

  constructor(props) {
    super(props)
    this.state = {
      clientType: 'web',
      mainHeight: '100%',
      mainTop: '0',
    }
  }

  componentDidMount() {
    const {clientType} = this.state
    const frame = document.getElementById('app')
    frame.className = clientType
    if (clientType === 'web') {
      this.resize({target: window})
      window.addEventListener('resize', this.resize, false)
    }
  }

  resize = (e) => {
    const target = e.target
    const height = target.innerHeight
    const frame = document.getElementById('app')
    if (height >= 900) {
      frame.style.height = '900px'
      frame.style.marginTop = `${(height - 900) / 2}px`
    } else {
      frame.style.height = '100%'
      frame.style.marginTop = '0'
    }
  }

  render() {
    const { clientType, mainHeight, mainTop } = this.state

    const config = {
      language: 'zh',
      token: '9uOXM6cFfpJBr03zw6612ervOsK4qnjH',
      apiRoot: 'https://xin-sandbox.asiainfo.com:16020/api',
      apiVersion: 'v1.0.0',
      // scheduleId: '20180615110813601_f9d2006c', // 日程事件id
      httpAgent: httpAgent('https://xin-sandbox.asiainfo.com:16020/api','v1.0.0'),
      closeCalendar: () => {},
      tost: tost,
      errorTost: errorTost,
      saveSuccess: () => {},
    }

    const scheduleInfo = {
      scheduleId: '20180917112650580_539cb27d', // 日程事件id
      // createDate: '20180709',
    }

    const editInfo = {
      // eventId: '20180815104058237_a97f1bee',
      // isRepeat: true,
      // repeatType: 'all',
    }
    
    return(
      <div className="kf-body">
        <div className={`${css.frame} s-bg-page`}>
          <KaraCalendarCreate config={config} scheduleInfo={scheduleInfo} editInfo={editInfo}/>
          <div className={`${css.aside} s-bg-primary small`}></div>
          <div className={css.body}></div>
        </div>
      </div>
    )
  }
}