export default (requests) => ({
  getMonth: () => // 月视图
    requests.post('/schedule/event/getList.month', {day: '201807'}),
  getUser: () => // 获取用户信息
    requests.get('/sdm/getCurrentStaff'),
  modifyRepeat: (params) => //编辑&删除重复
    requests.post('/schedule/event/modify.repeat', params),
  deleteSchedule: (id) => // 删除日程
    requests.post(`/schedule/event/delete/${id}`),
  saveSchedule: (params) => // 新增日程
    requests.post('/schedule/event/add', {scheduleEvent: params}),
  editSchedule: (params) => // 编辑日程
    requests.post('/schedule/event/modify', {scheduleEvent: params}),
  getScheduleDetail: (id) => // 获取事件详情
    requests.get(`/schedule/event/get/${id}`),
  getUserDefined: () => // 自定义事件类型
    requests.get('/schedule/eventType/getList/customized'),
  saveEvent: (saveId, saveName, iconCode, colorCode) => // 保存/修改自定义事件
    requests.post('/schedule/eventType/saveOrUpdate', {scheduleEventTypeInfo: {id: saveId, etname: saveName, icon: iconCode, color: colorCode}}),
  deleteEvent: (eventId) => //删除自定义事件
    requests.post(`/schedule/eventType/delete/${eventId}`, {id: eventId}),
  getEventLists: () => // 获取全部事件
    requests.get('/schedule/eventType/getList/all'),
  searchResult: (keyword, pageno, pagesize) => //搜索参与人
    requests.post('/search/schedule/event/invitees', {
      keywords: keyword,
      pageInfo: {
        pageNo: pageno || 1,
        pageSize: pagesize || 10,
      },
    }),
  recentInvitees: () => //最近日程参与人
    requests.get('/schedule/recentInvitees'),
  createGroupChat: (contactIds, name) => // 创建群聊
    requests.post('/webapi/channel/createchannel', {accountIdList: contactIds, channelName: name}),
})