/* eslint-disable react/no-string-refs, react/no-array-index-key */
import React from 'react';
import PropTypes from 'prop-types';
import style from './searchResultItem.scss';
import {Scroll} from 'karaui';


class SelectedItem extends React.Component {
  removeItem = (accountId, accountType) => {
    this.props.removeItem(accountId, accountType);
  }
  render() {
    const { selectedList } = this.props;
    if (!selectedList) {
      return <div className={style['n-hidden']} />;
    } else if (selectedList.length === 0) {
      return (
        <div className={(style.content)}>
          <p/>
        </div>
      );
    }
    const that = this;
    return (
      <div className={style['selected-list']}>
        <p className={style['select-title']}>
          已选择 ( <i>{selectedList.length}</i>人 )
        </p>
        <div className={style['l-choiced']}>
          <Scroll>
            <ul className={style.c}>
              {selectedList.map((i, key) =>
                <li key={key} title={i.accountName}>
                  <i
                    onClick={() => { that.removeItem(i.accountId, i.accountType); }}
                    className={`kccfont i-close small ${style['btn-selected']}`}
                  />
                  <img src={i.headIcon} alt="i.name" onError={this.useDefaultPic} />
                  <p>{i.accountName}</p>
                </li>)}
            </ul>
          </Scroll>
        </div>
        <div className={style.grayline} />
        <div
          className={style['u-button-save']}
          onClick={() => {
            that.props.save();
            that.props.addNew('close');
          }}
        >
          确认
        </div>
      </div>
    );
  }
}

SelectedItem.propTypes = {
  removeItem: PropTypes.func.isRequired,
  selectedList: PropTypes.arrayOf(PropTypes.object).isRequired,
};

export default SelectedItem;
