/**
 * Created by Berlin on 2018/6/29.
 */
import React from 'react';
import css from './participants.scss';
import {Scroll} from 'karaui';
import {inject, observer} from "mobx-react";

@inject('definedFunc')
@inject('calendarStore')
@observer

export default class Participants extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      isCreateChannel: false,
      addItem: false, // 添加新成员
      selectedList: [],
    }
  }

  componentWillMount() {
    const {invitees} = this.props;
    const inviteList = invitees ? invitees.sort() : [];
    let arr = [];
    if (inviteList && inviteList.length > 0) {
      inviteList.map(item => {
        arr.push({
          accountId: item.accountId,
          accountName: item.name,
          headIcon: item.icon,
        })
      })
      this.setState({ selectedList: arr })
      this.props.definedFunc.saveSelected(arr)
    }
  }

  componentDidUpdate() {
    if (this.props.definedFunc.channelId && this.props.definedFunc.channelId !== '' && !this.state.isCreateChannel) {
      this.props.definedFunc.setCreateChat(true);
      this.setState({ isCreateChannel: true })
    }
  }

  componentWillUnmount() {
    this.props.definedFunc.initSelected()
  }

  delMember = (n, selectedLists) => {
    if (n < 0) {
      return this;
    }
    this.setState({ delete: true });
    selectedLists.splice(n, 1);
    return selectedLists
  }

  save = (param) => {
    this.props.definedFunc.saveSelected(param, 'del');
  }

  isCreate = () => {
    this.props.definedFunc.setCreateChat(!this.state.isCreateChannel);
    this.setState({ isCreateChannel: !this.state.isCreateChannel })
  }

  render() {
    const {eventId, disabled} = this.props;
    const selectedLists = this.props.definedFunc.selectedLists.sort();
    const userInfo = this.props.calendarStore.userInfo;
    let newSelected = [];
    const isEditCreat = this.props.definedFunc.channelId && this.props.definedFunc.channelId !== '';
    if (eventId && eventId !== '') {
      newSelected = selectedLists;
    } else {
      newSelected = [userInfo].concat(selectedLists);
    }
    let isHeight = false
    if (eventId) {
      if (newSelected.length > 5) {
        isHeight = true;
      } else {
        isHeight = false;
      }
    } else {
      if (newSelected.length > 4) {
        isHeight = true;
      } else {
        isHeight = false;
      }
    }
    return <div className={`${css.participants} ${css.comPadding}`}>
      {
        !disabled ?
          <span className={`kccfont i-close ${css.closeRepeat}`} onClick={() => {this.props.closeBtn('isContractor')} }/> : null
      }
      <p className={css.caEdTitle}>
        参与人
        <span>
          已选(<i className={css.active}>{!eventId ? selectedLists.length + 1 : selectedLists.length}</i>)
        </span>
        <span style={{marginLeft: '6px'}}>将同步为参与人创建此日程</span>
      </p>
      <div
        className={`${css.contractorList} ${css.clearfix}`}
        style={isHeight ? {height: '144px'} : {height: '96px'}}
      >
        <Scroll>
          <div
            className={css['add-item']}
            onClick={this.props.addNew}
            style={disabled ? {display: 'none'} : {}}
          >
            <i className="kccfont i-add" />
          </div>
          {
            selectedLists ? newSelected.map((item, k) => {
              return <div key={k} className={css.selected}>
                {
                  k === 0 ?
                    <div className={css.creator}>
                      <i
                        className={'kccfont i-icon_finish'}
                      />
                    </div>
                    :
                    (!disabled ?
                      <i
                        className={'kccfont i-close'}
                        style={{color: '#ff8928'}}
                        onClick={() => { this.save(this.delMember(`${eventId && eventId !== '' ? k : k - 1}`, selectedLists)) }}
                      /> : null
                    )
                }
                <img alt="" src={item.headIcon} />
                <p>{item.accountName}</p>
              </div>}) :null
          }
        </Scroll>
      </div>
      <div
        className={css.createChannel}
        onClick={eventId !=='' && isEditCreat || disabled ? null : this.isCreate}
        style={eventId !=='' && isEditCreat || disabled ? {cursor: 'not-allowed'} : {}}
      >
        <i
          className={`kccfont ${this.state.isCreateChannel ? 'i-xuanzhong1' : 'i-xuanzhong'}`}
        />
        &nbsp;是否同时创建群组
      </div>
    </div>
  }
}
