/**
 * Created by Berlin on 2018/6/29.
 */
import React from 'react';
import {inject, observer} from "mobx-react"
import css from './remark.scss';
import Input from 'antd/lib/input'
const Textarea =Input.TextArea

@inject('calendarStore')
@inject('definedFunc')
@observer

export default class Remark extends React.Component {

  constructor(props) {
    super(props);

    this.state = {
      iptValue: '',
      isUrl: false,
    };

    this.styles = {
      height: '100%',
      border: 'none',
      overflowY: 'visible',
      resize: 'none',
      outline: 'none',
      padding: 0,
      borderRadius: 0,
      borderBottom: '1px solid #e5e5e5',
      background: '#fff',
      fontSize: '13px',
    };
  }

  componentWillMount() {
    if (this.props.remark) {
      this.linkfilter(this.props.remark)
      this.setState({ iptValue: this.props.remark })
    }
  }

  handleChange = (e) => {
    this.props.definedFunc.setRemark(e.target.value)
    this.setState({ iptValue: e.target.value });
  }

  linkfilter = (msg) => {
    var url=msg;
    var urlRegExp=new RegExp("((https|http|ftp|rtsp|mms|www)?:\/*\/*)[^\u4E00-\u9FA5]+" );
    var newmsg="";
    while (urlRegExp.exec(url) != null){
      if (!this.state.isUrl) {
        this.setState({ isUrl: true })
      }

      var pipeiurl = urlRegExp.exec(url);
      var newurl = `<a target='_blank' href=${pipeiurl[0]}>${pipeiurl[0]}</a>`;
      if (new RegExp(/\n/gm).test(pipeiurl[0])) {
        newurl = `${newurl}<br/>`
      }
      var urllength = pipeiurl[0].length;
      var start = url.indexOf(pipeiurl[0]);
      newmsg += url.substring(0,start).replace(/\n/gm, '<br/>') + newurl;
      // newmsg = newmsg.replace(/\n/gm, '<br/>')
      url = url.substring(start+urllength);
      var newMsg = newmsg + url;
      // newMsg = newMsg.replace(/\n/gm, '<br/>')
    }
    return newMsg
  }

  render() {
    const {disabled} = this.props;
    return <div className={`${css.remarkBody} ${css.comPadding}`}>
      {
        !disabled ?
          <span className={`kccfont i-close ${css.closeRepeat}`} onClick={() => {this.props.closeBtn('isRemark')} }/> : null
      }
      <p className={css.caEdTitle}>备注</p>
      {
        !this.state.isUrl || !disabled ?
          <Textarea
            style={this.styles}
            value={this.state.iptValue}
            autosize={{ minRows: 1.2, maxRows: 6 }}
            placeholder="输入备注内容"
            ref={e => this.input = e}
            onChange={e => this.handleChange(e)}
            disabled={disabled}
          /> :
          <p className={css.urlStyle} dangerouslySetInnerHTML={{__html: this.linkfilter(this.state.iptValue)}}/>
      }
    </div>
  }
}