/**
 * Created by Berlin on 2018/6/27.
 */
import React, {Component} from 'react'
import {configure} from 'mobx'
import {Provider} from 'mobx-react'
import configStore from './stores/configStore'
import calendarStore from './stores/calendarStore'
import contractor from './stores/contractor'
import definedFunc from './stores/diyFunc'
import KaraCalendarCreate from "./components/index";
import httpAgent from './api/httpAgent'

configure({
  enforceActions: true,
  isolateGlobalState: true,
})

class KS extends Component {
  constructor(props) {
    super(props)
  }

  render() {
    configStore.setConfig(this.props.config); // 把配置参数保存到 store
    const stores = {
      configStore,
      calendarStore,
      contractor,
      definedFunc,
    };
    return (
      <Provider {...stores} >
        <KaraCalendarCreate {...this.props} httpAgent={httpAgent(this.props.config.httpAgent)} />
      </Provider>
    )
  }
}

export default KS
