/**
 * Created by Berlin on 2018/7/3.
 */
import { observable, action } from 'mobx';

class CalendarStore {

  @observable eventLists = []; // 事件
  @observable userInfo = {}; // 个人信息
  @observable scheduleDetail = {}; // 事件信息

  @action setEventLists = res => {
    this.eventLists = res;
  }

  @action getUserInfo = res => {
    this.userInfo = {
      accountId: res.staffInfo.accountId,
      accountName: res.staffInfo.accountName,
      headIcon: res.staffInfo.headIcon,
    };
  }

  @action getScheduleDetail = res => {
    this.scheduleDetail = res;
  }

  @action initSchedule = () => {
    this.scheduleDetail = {}
  }

}

export default new CalendarStore();