/**
 * Created by Berlin on 2018/7/5.
 */
import { observable, action } from 'mobx';

const unRepeat = (arr) => {
  // 去除数组中重复对象
  const unique = {};
  arr.forEach((a) => { unique[JSON.stringify(a)] = 1; });
  // eslint-disable-next-line
  arr = Object.keys(unique).map(u => (JSON.parse(u)));
  return arr;
}

const invite = (res, inviteList, isDel) => {
  // 被选中参与人
  let newList;
  if (isDel === 'del') {
    newList = []
  } else {
    newList = inviteList
  }
  const lists = unRepeat(newList.concat(res.sort()));
  let invite = [];
  lists.forEach((item) => {
    invite.push(item.accountId);
  });
  return {
    selectedLists: lists,
    invitees: invite,
  };
}

class DefinedFunc {

  @observable eventContent = ''; // 事件内容
  @observable remark = ''; // 备注内容
  @observable invitees = []; // 参与人
  @observable channelId = ''; // 群聊频道id
  @observable isCreateChat = false; // 是否同时创建群聊
  @observable selectedLists = []; // 选择列表
  @observable eventType = ''; // 事件类型
  @observable repeatType = ''; // 重复方式
  @observable repeatEndDate = ''; // 重复结束时间
  @observable repeatIsOver = 'no'; // 指定重复时间
  @observable remindTimes = []; // 提醒时间
  @observable remindTypes = ''; // 提醒类别
  @observable editRepeat = 'noRepeat'; // 编辑重复事件
  @observable delRepeat = ''; // 删除重复事件

  // 参与人
  @action saveSelected = (res, isDel) => {
    const result = invite(res, this.selectedLists, isDel)
    this.invitees = result.invitees;
    this.selectedLists = result.selectedLists;
  }

  // 清空参与人
  @action initSelected = () => {
    this.invitees = [];
    this.selectedLists = [];
  }

  @action setCreateChat = res => {
    this.isCreateChat = res;
  }

  // 频道
  @action setChannel = res => {
    this.channelId = res;
  }

  // 事件内容
  @action setEventContent = res => {
    this.eventContent = res;
  }

  // 备注
  @action setRemark = res => {
    this.remark = res;
  }

  // 事件类型
  @action setEventType = res => {
    this.eventType = res;
  }

  // 提醒类别
  @action setNoticeType = res => {
    this.remindTypes = res;
  }

  // 提醒时间
  @action setNoticeTime = res => {
    this.remindTimes = res;
  }

  // 重复
  @action setRepeatType = (type, date)  => {
    this.repeatType = type;
    this.repeatEndDate = date;
  }

  // 是否指定重复事件
  @action setRepeatIsOver = res => {
    this.repeatIsOver = res;
  }

  // 编辑重复事件
  @action setEditRepeat = res => {
    this.editRepeat = res;
  }

  // 删除重复事件
  @action setDelRepeat = res => {
    this.delRepeat = res;
  }

  // 卸载组件 清空数据
  @action initDate = () => {
    this.eventContent = ''; // 事件内容
    this.remark = ''; // 备注内容
    this.invitees = []; // 参与人
    this.channelId = ''; // 群聊频道id
    this.isCreateChat = false; // 是否同时创建群聊
    this.selectedLists = []; // 选择列表
    this.eventType = ''; // 事件类型
    this.repeatType = ''; // 重复方式
    this.repeatEndDate = ''; // 重复结束时间
    this.repeatIsOver = 'no'; // 指定重复时间
    this.remindTimes = []; // 提醒时间
    this.remindTypes = ''; // 提醒类别
    this.editRepeat = 'noRepeat'; // 编辑重复事件
    this.delRepeat = ''; // 删除重复事件
  }
}

export default new DefinedFunc();
